=== debian/changelog ===
rocm-smi-lib (6.4.1-1) unstable; urgency=medium

  [ Cordell Bloor ]
  * Upload to unstable
  * Forwarded d/p/0004-revert-remove-reset-partition.patch
  * Add d/gbp.conf to follow DEP-14
  * Update my email address
  * d/control: drop inactive maintainers from uploaders
  * d/control: add myself to uploaders

  [ Kentaro Hayashi ]
  * Use d/watch 5

 -- Cordell Bloor <cgmb@debian.org>  Thu, 30 Oct 2025 16:01:37 -0600

rocm-smi-lib (6.4.1-1~exp1) experimental; urgency=medium

  * Team upload.

  * New upstream version 6.4.1
  * Refresh patches
    * Drop d/p/0001-remove-const-decorator.patch applied upstream
    * Add d/p/0004-revert-remove-reset-partition.patch to restore the
      rsmi_dev_compute_partition_reset and rsmi_dev_memory_partition_reset
      functions that were removed upstream
  * Update copyright for new upstream version
  * Add libdrm-dev to B-D as required for new upstream version
  * Update standards version to 4.7.2
  * d/control: update maintainer name from ROCm Team to Debian ROCm Team
    for consistency with other packages

 -- Cordell Bloor <cgmb@slerp.xyz>  Mon, 23 Jun 2025 14:40:41 -0600
