=== debian/tests/control ===
Test-Command: python3 -c "import rsmiBindings; print('OK')"
Depends: @
Restrictions: allow-stderr
Features: test-name=py_binding_can_be_imported

Test-Command: rocm-smi
Depends: @
Restrictions: allow-stderr
Features: test-name=py_cli_can_import_correctly

Test-Command: rocm-smi -S
Depends: @
Restrictions: allow-stderr
Features: test-name=regression_bug_1031121
