=== debian/watch ===
Version: 5

Source: https://api.github.com/repos/ROCm/rocm_smi_lib/tags?per_page=100
Matching-Pattern: https://api.github.com/repos/ROCm/rocm_smi_lib/tarball/refs/tags/rocm-@ANY_VERSION@
Filenamemangle: s%.*/rocm-@ANY_VERSION@%@PACKAGE@-$1.tar.gz%
Searchmode: plain
